Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_lim2_update.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_lim2_update.F90	(revision 3680)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_lim2_update.F90	(revision 3680)
@@ -0,0 +1,267 @@
+#define TWO_WAY
+
+MODULE agrif_lim2_update
+   !!======================================================================
+   !!                       ***  MODULE agrif_lim2_update ***
+   !! Nesting module :  update surface ocean boundary condition over ice
+   !!                   from a child grif
+   !! Sea-Ice model  :  LIM 2.0 Sea ice model time-stepping
+   !!======================================================================
+   !! History :  2.0   !  04-2008  (F. Dupont)  initial version
+   !!            3.4   !  08-2012  (R. Benshila, C. Herbaut) update and EVP
+   !!----------------------------------------------------------------------
+#if defined key_agrif && defined key_lim2
+   !!----------------------------------------------------------------------
+   !!   'key_lim2'  :                                 LIM 2.0 sea-ice model
+   !!   'key_agrif' :                                 AGRIF library 
+   !!----------------------------------------------------------------------
+   !!   agrif_update_lim2  : update sea-ice model on boundaries or total
+   !!                        sea-ice area for velocities and ice properties
+   !!   update_adv_ice     : sea-ice properties
+   !!   update_u_ice       : zonal ice velocity
+   !!   update_v_ice       : meridional ice velocity
+   !!----------------------------------------------------------------------
+   USE ice_2
+   USE dom_ice_2
+   USE sbc_oce
+   USE dom_oce
+   USE agrif_oce
+   USE agrif_ice 
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC agrif_update_lim2
+
+   !!----------------------------------------------------------------------
+   !! NEMO/NST 3.4 , LOCEAN-IPSL (2012)
+   !! $Id$
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE agrif_update_lim2 ( kt )
+      !!----------------------------------------------------------------------
+      !!                     *** ROUTINE agrif_update_lim2 ***
+      !! ** Method  :   Call the hydrostaticupdate pressure at the boundary or
+      !!                the entire domain 
+      !!
+      !! ** Action : - Update (u_ice,v_ice) and ice tracers
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: kt
+      !!
+      REAL(wp), DIMENSION(jpi,jpj)  :: zvel
+      REAL(wp), DIMENSION(jpi,jpj,7):: zadv
+      !!----------------------------------------------------------------------
+      !
+      IF((Agrif_NbStepint() .NE. (Agrif_irhot()-1)).AND.(kt /= 0)) RETURN
+
+      Agrif_UseSpecialValueInUpdate = .TRUE.
+      Agrif_SpecialValueFineGrid = 0.
+
+# if defined TWO_WAY
+      IF( MOD(nbcline,nbclineupdate) == 0) THEN
+         CALL Agrif_Update_Variable( zadv , adv_ice_id , procname = update_adv_ice  )
+         CALL Agrif_Update_Variable( zvel , u_ice_id   , procname = update_u_ice    )
+         CALL Agrif_Update_Variable( zvel , v_ice_id   , procname = update_v_ice    )
+      ELSE
+         CALL Agrif_Update_Variable( zadv , adv_ice_id , locupdate=(/0,2/), procname = update_adv_ice  )
+         CALL Agrif_Update_Variable( zvel , u_ice_id   , locupdate=(/0,1/), procname = update_u_ice    )
+         CALL Agrif_Update_Variable( zvel , v_ice_id   , locupdate=(/0,1/), procname = update_v_ice    )
+      ENDIF
+# endif
+      !
+   END SUBROUTINE agrif_update_lim2
+
+
+   SUBROUTINE update_adv_ice( tabres, i1, i2, j1, j2, before )
+      !!-----------------------------------------------------------------------
+      !!                        *** ROUTINE update_adv_ice ***
+      !! ** Method  : Compute the mass properties on the fine grid and recover
+      !!              the properties per mass on the coarse grid
+      !!-----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: i1, i2, j1, j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2,7), INTENT(inout) :: tabres
+      LOGICAL, INTENT(in) :: before
+      !!
+      INTEGER :: ji, jj
+      REAL(wp) :: zrhox, zrhoy
+      REAL(wp) :: z1_area
+      !!-----------------------------------------------------------------------
+      !
+      IF( before ) THEN
+         zrhox = Agrif_Rhox()
+         zrhoy = Agrif_Rhoy()
+         DO jj=j1,j2
+            DO ji=i1,i2
+               tabres(ji,jj, 1) = frld  (ji,jj  ) * area(ji,jj)
+               tabres(ji,jj, 2) = hicif (ji,jj  ) * area(ji,jj)
+               tabres(ji,jj, 3) = hsnif (ji,jj  ) * area(ji,jj)
+               tabres(ji,jj, 4) = tbif  (ji,jj,1) * area(ji,jj)
+               tabres(ji,jj, 5) = tbif  (ji,jj,2) * area(ji,jj)
+               tabres(ji,jj, 6) = tbif  (ji,jj,3) * area(ji,jj)
+               tabres(ji,jj, 7) = qstoif(ji,jj  ) * area(ji,jj)
+            END DO
+         END DO
+         tabres = zrhox * zrhoy * tabres
+      ELSE
+         DO jj=j1,j2
+            DO ji=i1,i2
+               z1_area = 1. / area(ji,jj) * tms(ji,jj)
+               frld  (ji,jj)   = tabres(ji,jj, 1) * z1_area
+               hicif (ji,jj)   = tabres(ji,jj, 2) * z1_area
+               hsnif (ji,jj)   = tabres(ji,jj, 3) * z1_area
+               tbif  (ji,jj,1) = tabres(ji,jj, 4) * z1_area
+               tbif  (ji,jj,2) = tabres(ji,jj, 5) * z1_area
+               tbif  (ji,jj,3) = tabres(ji,jj, 6) * z1_area
+               qstoif(ji,jj)   = tabres(ji,jj, 7) * z1_area
+            END DO
+         END DO
+      ENDIF
+      !
+   END SUBROUTINE update_adv_ice
+
+
+# if defined key_lim2_vp
+   SUBROUTINE update_u_ice( tabres, i1, i2, j1, j2, before )
+      !!-----------------------------------------------------------------------
+      !!                        *** ROUTINE update_u_ice ***
+      !! ** Method  : Update the fluxes and recover the properties (B-grid)
+      !!-----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: i1, i2, j1, j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2), INTENT(inout) :: tabres
+      LOGICAL, INTENT(in) :: before
+      !!
+      INTEGER :: ji, jj
+      REAL(wp) :: zrhoy
+      !!-----------------------------------------------------------------------
+      !
+      IF( before ) THEN
+         zrhoy = Agrif_Rhoy()
+         DO jj=MAX(j1,2),j2
+            DO ji=MAX(i1,2),i2
+               tabres(ji,jj) = e2f(ji-1,jj-1) * u_ice(ji,jj)
+            END DO
+         END DO
+         tabres = zrhoy * tabres
+      ELSE
+         DO jj= MAX(j1,2),j2
+            DO ji=MAX(i1,2),i2
+               u_ice(ji,jj) = tabres(ji,jj) / (e2f(ji-1,jj-1))
+               u_ice(ji,jj) = u_ice(ji,jj) * tmu(ji,jj)
+            END DO
+         END DO
+      ENDIF
+      !
+   END SUBROUTINE update_u_ice
+
+
+   SUBROUTINE update_v_ice( tabres, i1, i2, j1, j2, before )
+      !!-----------------------------------------------------------------------
+      !!                    *** ROUTINE update_v_ice ***
+      !! ** Method  : Update the fluxes and recover the properties (B-grid)
+      !!-----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: i1,i2,j1,j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2),  INTENT(inout) :: tabres
+      LOGICAL, INTENT(in) :: before
+      !!
+      INTEGER :: ji, jj
+      REAL(wp) :: zrhox
+      !!-----------------------------------------------------------------------
+      !
+      IF( before ) THEN
+         zrhox = Agrif_Rhox()
+         DO jj=MAX(j1,2),j2
+            DO ji=MAX(i1,2),i2
+               tabres(ji,jj) = e1f(ji-1,jj-1) * v_ice(ji,jj)
+            END DO
+         END DO
+         tabres = zrhox * tabres
+      ELSE
+         DO jj=j1,j2
+            DO ji=i1,i2
+               v_ice(ji,jj) = tabres(ji,jj) / (e1f(ji-1,jj-1))
+               v_ice(ji,jj) = v_ice(ji,jj) * tmu(ji,jj)
+            END DO
+         END DO
+      ENDIF
+      !
+   END SUBROUTINE update_v_ice
+# else
+   SUBROUTINE update_u_ice( tabres, i1, i2, j1, j2, before )
+      !!-----------------------------------------------------------------------
+      !!                        *** ROUTINE update_u_ice ***
+      !! ** Method  : Update the fluxes and recover the properties (C-grid)
+      !!-----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: i1, i2, j1, j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2), INTENT(inout) :: tabres
+      LOGICAL, INTENT(in) :: before
+      !!
+      INTEGER :: ji, jj
+      REAL(wp) :: zrhoy
+      !!-----------------------------------------------------------------------
+      !
+      IF( before ) THEN
+         zrhoy = Agrif_Rhoy()
+         DO jj=MAX(j1,2),j2
+            DO ji=MAX(i1,2),i2
+               tabres(ji,jj) = e2u(ji,jj) * u_ice(ji,jj)
+            END DO
+         END DO
+         tabres = zrhoy * tabres
+      ELSE
+         DO jj=MAX(j1,2),j2
+            DO ji=MAX(i1,2),i2
+               u_ice(ji,jj) = tabres(ji,jj) / (e2u(ji,jj))
+               u_ice(ji,jj) = u_ice(ji,jj) * tmu(ji,jj)
+            END DO
+         END DO
+      ENDIF
+      ! 
+   END SUBROUTINE update_u_ice
+
+
+   SUBROUTINE update_v_ice( tabres, i1, i2, j1, j2, before )
+      !!-----------------------------------------------------------------------
+      !!                    *** ROUTINE update_v_ice ***
+      !! ** Method  : Update the fluxes and recover the properties (C-grid)
+      !!-----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: i1,i2,j1,j2
+      REAL(wp), DIMENSION(i1:i2,j1:j2),  INTENT(inout) :: tabres
+      LOGICAL, INTENT(in) :: before
+      !!
+      INTEGER :: ji, jj
+      REAL(wp) :: zrhox
+      !!-----------------------------------------------------------------------
+      !
+      IF( before ) THEN
+         zrhox = Agrif_Rhox()
+         DO jj=MAX(j1,2),j2
+            DO ji=MAX(i1,2),i2
+               tabres(ji,jj) = e1v(ji,jj) * v_ice(ji,jj)
+            END DO
+         END DO
+         tabres = zrhox * tabres
+      ELSE
+         DO jj=j1,j2
+            DO ji=i1,i2
+               v_ice(ji,jj) = tabres(ji,jj) / (e1v(ji,jj))
+               v_ice(ji,jj) = v_ice(ji,jj) * tmv(ji,jj)
+            END DO
+         END DO
+      ENDIF
+      !
+   END SUBROUTINE update_v_ice
+# endif
+
+#else
+CONTAINS
+   SUBROUTINE agrif_lim2_update_empty
+      !!---------------------------------------------
+      !!   *** ROUTINE agrif_lim2_update_empty ***
+      !!---------------------------------------------
+      WRITE(*,*)  'agrif_lim2_update : You should not have seen this print! error?'
+   END SUBROUTINE agrif_lim2_update_empty
+#endif
+END MODULE agrif_lim2_update
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90	(revision 3680)
@@ -25,4 +25,5 @@
 
    !                                              !!! OLD namelist names
+   INTEGER , PUBLIC ::   nbcline = 0               !: update counter
    INTEGER , PUBLIC ::   nbclineupdate             !: update frequency 
    REAL(wp), PUBLIC ::   visc_tra                  !: sponge coeff. for tracers
Index: /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90
===================================================================
--- /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90	(revision 3679)
+++ /branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90	(revision 3680)
@@ -1,3 +1,3 @@
-#define SPONGE
+#define SPONGE && define SPONGE_TOP
 
 Module agrif_opa_sponge
@@ -13,6 +13,8 @@
    PRIVATE
 
-   PUBLIC Agrif_Sponge_Tra, Agrif_Sponge_Dyn, interptsn, interpun, interpvn
-
+   PUBLIC Agrif_Sponge, Agrif_Sponge_Tra, Agrif_Sponge_Dyn, interptsn, interpun, interpvn
+
+  !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/NST 3.3 , NEMO Consortium (2010)
@@ -27,11 +29,8 @@
       !!   *** ROUTINE Agrif_Sponge_Tra ***
       !!---------------------------------------------
-#include "domzgr_substitute.h90"
       !!
       INTEGER :: ji,jj,jk,jn
-      INTEGER :: spongearea
       REAL(wp) :: timecoeff
       REAL(wp) :: ztsa, zabe1, zabe2, zbtr
-      REAL(wp), POINTER, DIMENSION(:,:    ) :: localviscsponge
       REAL(wp), POINTER, DIMENSION(:,:    ) :: ztu, ztv
       REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztab
@@ -39,5 +38,5 @@
 
 #if defined SPONGE
-      CALL wrk_alloc( jpi, jpj, localviscsponge, ztu, ztv )
+      CALL wrk_alloc( jpi, jpj, ztu, ztv )
       CALL wrk_alloc( jpi, jpj, jpk, jpts, ztab, tsbdiff  )
 
@@ -52,72 +51,5 @@
       tsbdiff(:,:,:,:) = tsb(:,:,:,:) - ztab(:,:,:,:)
 
-      spongearea = 2 + 2 * Agrif_irhox()
-
-      localviscsponge = 0.
-      
-      IF (.NOT. spongedoneT) THEN
-         spe1ur(:,:) = 0.
-         spe2vr(:,:) = 0.
-
-      IF ((nbondi == -1).OR.(nbondi == 2)) THEN
-         DO ji = 2, spongearea
-            localviscsponge(ji,:) = visc_tra * (spongearea-ji)/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur(2:spongearea-1,:)=0.5 * (localviscsponge(2:spongearea-1,:) + localviscsponge(3:spongearea,:)) &
-	       * e2u(2:spongearea-1,:) / e1u(2:spongearea-1,:)
-
-         spe2vr(2:spongearea,1:jpjm1) = 0.5 * (localviscsponge(2:spongearea,1:jpjm1) + &
-	          localviscsponge(2:spongearea,2:jpj)) &
-	        * e1v(2:spongearea,1:jpjm1) / e2v(2:spongearea,1:jpjm1)
-      ENDIF
-
-      IF ((nbondi == 1).OR.(nbondi == 2)) THEN
-         DO ji = nlci-spongearea + 1,nlci-1
-            localviscsponge(ji,:) = visc_tra * (ji - (nlci-spongearea+1))/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur(nlci-spongearea + 1:nlci-2,:)=0.5 * (localviscsponge(nlci-spongearea + 1:nlci-2,:) + &
-	        localviscsponge(nlci-spongearea + 2:nlci-1,:)) &
-	       * e2u(nlci-spongearea + 1:nlci-2,:) / e1u(nlci-spongearea + 1:nlci-2,:)
-
-         spe2vr(nlci-spongearea + 1:nlci-1,1:jpjm1) = 0.5 * (localviscsponge(nlci-spongearea + 1:nlci-1,1:jpjm1) &
-	           + localviscsponge(nlci-spongearea + 1:nlci-1,2:jpj)) &
-	        * e1v(nlci-spongearea + 1:nlci-1,1:jpjm1) / e2v(nlci-spongearea + 1:nlci-1,1:jpjm1)
-      ENDIF
-
-
-      IF ((nbondj == -1).OR.(nbondj == 2)) THEN
-         DO jj = 2, spongearea
-            localviscsponge(:,jj) = visc_tra * (spongearea-jj)/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur(1:jpim1,2:spongearea)=0.5 * (localviscsponge(1:jpim1,2:spongearea) + &
-	        localviscsponge(2:jpi,2:spongearea)) &
-	       * e2u(1:jpim1,2:spongearea) / e1u(1:jpim1,2:spongearea)
-
-         spe2vr(:,2:spongearea-1) = 0.5 * (localviscsponge(:,2:spongearea-1) + &
-	          localviscsponge(:,3:spongearea)) &
-	        * e1v(:,2:spongearea-1) / e2v(:,2:spongearea-1)
-      ENDIF
-
-      IF ((nbondj == 1).OR.(nbondj == 2)) THEN
-         DO jj = nlcj-spongearea + 1,nlcj-1
-            localviscsponge(:,jj) = visc_tra * (jj - (nlcj-spongearea+1))/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur(1:jpim1,nlcj-spongearea + 1:nlcj-1)=0.5 * (localviscsponge(1:jpim1,nlcj-spongearea + 1:nlcj-1) + &
-	         localviscsponge(2:jpi,nlcj-spongearea + 1:nlcj-1)) &
-	       * e2u(1:jpim1,nlcj-spongearea + 1:nlcj-1) / e1u(1:jpim1,nlcj-spongearea + 1:nlcj-1)
-
-         spe2vr(:,nlcj-spongearea + 1:nlcj-2) = 0.5 * (localviscsponge(:,nlcj-spongearea + 1:nlcj-2) + &
-	         localviscsponge(:,nlcj-spongearea + 2:nlcj-1)) &
-	        * e1v(:,nlcj-spongearea + 1:nlcj-2) / e2v(:,nlcj-spongearea + 1:nlcj-2)
-      ENDIF
-      
-         spbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:))
-
-         spongedoneT = .TRUE.
-      ENDIF
+      CALL Agrif_Sponge
 
       DO jn = 1, jpts
@@ -147,5 +79,5 @@
       ENDDO
 
-      CALL wrk_dealloc( jpi, jpj, localviscsponge, ztu, ztv )
+      CALL wrk_dealloc( jpi, jpj, ztu, ztv )
       CALL wrk_dealloc( jpi, jpj, jpk, jpts, ztab, tsbdiff  )
 #endif
@@ -157,11 +89,8 @@
       !!   *** ROUTINE Agrif_Sponge_dyn ***
       !!---------------------------------------------
-#include "domzgr_substitute.h90"
       !!
       INTEGER :: ji,jj,jk
-      INTEGER :: spongearea
       REAL(wp) :: timecoeff
       REAL(wp) :: ze2u, ze1v, zua, zva, zbtr
-      REAL(wp), POINTER, DIMENSION(:,:) :: localviscsponge
       REAL(wp), POINTER, DIMENSION(:,:,:) :: ubdiff, vbdiff
       REAL(wp), POINTER, DIMENSION(:,:,:) :: rotdiff, hdivdiff
@@ -169,5 +98,4 @@
 
 #if defined SPONGE
-      CALL wrk_alloc( jpi, jpj, localviscsponge )
       CALL wrk_alloc( jpi, jpj, jpk, ztab, ubdiff, vbdiff, rotdiff, hdivdiff )
 
@@ -180,5 +108,5 @@
       Agrif_UseSpecialValue = .FALSE.
 
-      ubdiff(:,:,:) = (ub(:,:,:) - ztab(:,:,:))*umask(:,:,:)
+      ubdiff(:,:,:) = ( ub(:,:,:) - ztab(:,:,:) ) * umask(:,:,:)
 
       ztab = 0.e0
@@ -188,74 +116,11 @@
       Agrif_UseSpecialValue = .FALSE.
 
-      vbdiff(:,:,:) = (vb(:,:,:) - ztab(:,:,:))*vmask(:,:,:)
-
-      spongearea = 2 + 2 * Agrif_irhox()
-
-      localviscsponge = 0.
-
-      IF (.NOT. spongedoneU) THEN
-         spe1ur2(:,:) = 0.
-         spe2vr2(:,:) = 0.
-
-      IF ((nbondi == -1).OR.(nbondi == 2)) THEN
-         DO ji = 2, spongearea
-            localviscsponge(ji,:) = visc_dyn * (spongearea-ji)/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur2(2:spongearea-1,:)=0.5 * (localviscsponge(2:spongearea-1,:) + localviscsponge(3:spongearea,:))
-
-         spe2vr2(2:spongearea,1:jpjm1) = 0.5 * (localviscsponge(2:spongearea,1:jpjm1) + &
-	          localviscsponge(2:spongearea,2:jpj))
-      ENDIF
-
-      IF ((nbondi == 1).OR.(nbondi == 2)) THEN
-         DO ji = nlci-spongearea + 1,nlci-1
-            localviscsponge(ji,:) = visc_dyn * (ji - (nlci-spongearea+1))/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur2(nlci-spongearea + 1:nlci-2,:)=0.5 * (localviscsponge(nlci-spongearea + 1:nlci-2,:) + &
-	        localviscsponge(nlci-spongearea + 2:nlci-1,:))
-
-         spe2vr2(nlci-spongearea + 1:nlci-1,1:jpjm1) = 0.5 * (localviscsponge(nlci-spongearea + 1:nlci-1,1:jpjm1) &
-	           + localviscsponge(nlci-spongearea + 1:nlci-1,2:jpj))
-      ENDIF
-
-
-      IF ((nbondj == -1).OR.(nbondj == 2)) THEN
-         DO jj = 2, spongearea
-            localviscsponge(:,jj) = visc_dyn * (spongearea-jj)/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur2(1:jpim1,2:spongearea)=0.5 * (localviscsponge(1:jpim1,2:spongearea) + &
-	        localviscsponge(2:jpi,2:spongearea))
-
-         spe2vr2(:,2:spongearea-1) = 0.5 * (localviscsponge(:,2:spongearea-1) + &
-	          localviscsponge(:,3:spongearea))
-      ENDIF
-
-      IF ((nbondj == 1).OR.(nbondj == 2)) THEN
-         DO jj = nlcj-spongearea + 1,nlcj-1
-            localviscsponge(:,jj) = visc_dyn * (jj - (nlcj-spongearea+1))/real(spongearea-2)
-         ENDDO
-	 
-	 spe1ur2(1:jpim1,nlcj-spongearea + 1:nlcj-1)=0.5 * (localviscsponge(1:jpim1,nlcj-spongearea + 1:nlcj-1) + &
-	         localviscsponge(2:jpi,nlcj-spongearea + 1:nlcj-1))
-
-         spe2vr2(:,nlcj-spongearea + 1:nlcj-2) = 0.5 * (localviscsponge(:,nlcj-spongearea + 1:nlcj-2) + &
-	         localviscsponge(:,nlcj-spongearea + 2:nlcj-1))
-      ENDIF
-
-         spongedoneU = .TRUE.
-	 
-	  spbtr3(:,:) = 1./( e1f(:,:) * e2f(:,:))
-      ENDIF
-      
-      IF (.NOT. spongedoneT) THEN
-        spbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:))      
-      ENDIF
-      
-      DO jk=1,jpkm1
-      ubdiff(:,:,jk) = ubdiff(:,:,jk) * spe1ur2(:,:)
-      vbdiff(:,:,jk) = vbdiff(:,:,jk) * spe2vr2(:,:)
+      vbdiff(:,:,:) = ( vb(:,:,:) - ztab(:,:,:) ) * vmask(:,:,:)
+
+      CALL Agrif_Sponge
+
+      DO jk = 1,jpkm1
+         ubdiff(:,:,jk) = ubdiff(:,:,jk) * spe1ur2(:,:)
+         vbdiff(:,:,jk) = vbdiff(:,:,jk) * spe2vr2(:,:)
       ENDDO
       
@@ -272,11 +137,8 @@
             DO ji = 2, jpim1   ! vector opt.
                zbtr = spbtr2(ji,jj) / fse3t(ji,jj,jk)
-               hdivdiff(ji,jj,jk) =   &
-                  (  e2u(ji,jj)*fse3u(ji,jj,jk) * & 
-                  ubdiff(ji,jj,jk) - e2u(ji-1,jj  )* &
-                  fse3u(ji-1,jj  ,jk)  * ubdiff(ji-1,jj  ,jk)       &
-                  + e1v(ji,jj)*fse3v(ji,jj,jk) * &
-                  vbdiff(ji,jj,jk) - e1v(ji  ,jj-1)* &
-                  fse3v(ji  ,jj-1,jk)  * vbdiff(ji  ,jj-1,jk)  ) * zbtr
+               hdivdiff(ji,jj,jk) =  (  e2u(ji  ,jj  ) * fse3u(ji  ,jj  ,jk) * ubdiff(ji  ,jj  ,jk)     &
+                  &                   - e2u(ji-1,jj  ) * fse3u(ji-1,jj  ,jk) * ubdiff(ji-1,jj  ,jk)     &
+                  &                   + e1v(ji  ,jj  ) * fse3v(ji  ,jj  ,jk) * vbdiff(ji  ,jj  ,jk)     &
+                  &                   - e1v(ji  ,jj-1) * fse3v(ji  ,jj-1,jk) * vbdiff(ji  ,jj-1,jk)  ) * zbtr
             END DO
          END DO
@@ -286,6 +148,6 @@
                zbtr = spbtr3(ji,jj) * fse3f(ji,jj,jk)
                rotdiff(ji,jj,jk) = (  e2v(ji+1,jj  ) * vbdiff(ji+1,jj  ,jk) - e2v(ji,jj) * vbdiff(ji,jj,jk)    &
-                  &              - e1u(ji  ,jj+1) * ubdiff(ji  ,jj+1,jk) + e1u(ji,jj) * ubdiff(ji,jj,jk)  ) &
-                  &           * fmask(ji,jj,jk) * zbtr
+                  &                 - e1u(ji  ,jj+1) * ubdiff(ji  ,jj+1,jk) + e1u(ji,jj) * ubdiff(ji,jj,jk)  ) &
+                  &               * fmask(ji,jj,jk) * zbtr
             END DO
          END DO
@@ -298,15 +160,10 @@
          DO jj = 2, jpjm1
             DO ji = 2, jpim1   ! vector opt.
-               ze2u = rotdiff (ji,jj,jk)
-               ze1v = hdivdiff(ji,jj,jk)
                ! horizontal diffusive trends
-               zua = - ( ze2u - rotdiff (ji,jj-1,jk)) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )   &
-                  + ( hdivdiff(ji+1,jj,jk) - ze1v      &
-                  ) / e1u(ji,jj)
-
-               zva = + ( ze2u - rotdiff (ji-1,jj,jk)) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )   &
-                  + ( hdivdiff(ji,jj+1,jk) - ze1v    &
-                  ) / e2v(ji,jj)
-
+               zua = - ( rotdiff (ji  ,jj,jk) - rotdiff (ji,jj-1,jk) ) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )   &
+                     + ( hdivdiff(ji+1,jj,jk) - hdivdiff(ji,jj  ,jk) ) / e1u(ji,jj)
+
+               zva = + ( rotdiff (ji,jj  ,jk) - rotdiff (ji-1,jj,jk) ) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )   &
+                     + ( hdivdiff(ji,jj+1,jk) - hdivdiff(ji  ,jj,jk) ) / e2v(ji,jj)
                ! add it to the general momentum trends
                ua(ji,jj,jk) = ua(ji,jj,jk) + zua
@@ -317,17 +174,130 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      CALL wrk_dealloc( jpi, jpj, localviscsponge )
       CALL wrk_dealloc( jpi, jpj, jpk, ztab, ubdiff, vbdiff, rotdiff, hdivdiff )
-
 #endif
 
    END SUBROUTINE Agrif_Sponge_dyn
 
+   SUBROUTINE Agrif_Sponge
+      !!---------------------------------------------
+      !!   *** ROUTINE  Agrif_Sponge ***
+      !!---------------------------------------------
+      INTEGER  :: ji,jj,jk
+      INTEGER  :: ispongearea, ilci, ilcj
+      REAL(wp) :: z1spongearea
+      REAL(wp), POINTER, DIMENSION(:,:) :: zlocalviscsponge
+
+#if defined SPONGE || defined SPONGE_TOP
+
+      CALL wrk_alloc( jpi, jpj, zlocalviscsponge )
+
+      ispongearea  = 2 + 2 * Agrif_irhox()
+      ilci = nlci - ispongearea
+      ilcj = nlcj - ispongearea 
+      z1spongearea = 1._wp / REAL( ispongearea - 2 )
+      spbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
+
+      ! Tracers
+      IF( .NOT. spongedoneT ) THEN
+         zlocalviscsponge(:,:) = 0.
+         spe1ur(:,:) = 0.
+         spe2vr(:,:) = 0.
+
+         IF( (nbondi == -1) .OR. (nbondi == 2) ) THEN
+            DO ji = 2, ispongearea
+               zlocalviscsponge(ji,:) = visc_tra * ( ispongearea-ji ) * z1spongearea
+            ENDDO
+            spe1ur(2:ispongearea-1,:      ) = 0.5 * ( zlocalviscsponge(2:ispongearea-1,:      ) + zlocalviscsponge(3:ispongearea,:    ) ) &
+               &                         * e2u(2:ispongearea-1,:      ) / e1u(2:ispongearea-1,:      )
+            spe2vr(2:ispongearea  ,1:jpjm1) = 0.5 * ( zlocalviscsponge(2:ispongearea  ,1:jpjm1) + zlocalviscsponge(2:ispongearea,2:jpj) ) &
+               &                         * e1v(2:ispongearea  ,1:jpjm1) / e2v(2:ispongearea  ,1:jpjm1)
+         ENDIF
+
+         IF( (nbondi == 1) .OR. (nbondi == 2) ) THEN
+            DO ji = ilci+1,nlci-1
+               zlocalviscsponge(ji,:) = visc_tra * (ji - (ilci+1) ) * z1spongearea
+            ENDDO
+  
+            spe1ur(ilci+1:nlci-2,:      ) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-2,:) + zlocalviscsponge(ilci+2:nlci-1,:) )  &
+               &                                   * e2u(ilci+1:nlci-2,:) / e1u(ilci+1:nlci-2,:)
+
+            spe2vr(ilci+1:nlci-1,1:jpjm1) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-1,1:jpjm1) + zlocalviscsponge(ilci+1:nlci-1,2:jpj  )  ) & 
+               &                                   * e1v(ilci+1:nlci-1,1:jpjm1) / e2v(ilci+1:nlci-1,1:jpjm1)
+         ENDIF
+
+         IF( (nbondj == -1) .OR. (nbondj == 2) ) THEN
+            DO jj = 2, ispongearea
+               zlocalviscsponge(:,jj) = visc_tra * ( ispongearea-jj ) * z1spongearea
+            ENDDO
+            spe1ur(1:jpim1,2:ispongearea  ) = 0.5 * ( zlocalviscsponge(1:jpim1,2:ispongearea) + zlocalviscsponge(2:jpi,2:ispongearea) ) &
+               &                                * e2u(1:jpim1,2:ispongearea) / e1u(1:jpim1,2:ispongearea)
+   
+            spe2vr(:      ,2:ispongearea-1) = 0.5 * ( zlocalviscsponge(:,2:ispongearea-1)     + zlocalviscsponge(:,3:ispongearea)     ) &
+               &                                  * e1v(:,2:ispongearea-1) / e2v(:,2:ispongearea-1)
+         ENDIF
+
+         IF( (nbondj == 1) .OR. (nbondj == 2) ) THEN
+            DO jj = ilcj+1,nlcj-1
+               zlocalviscsponge(:,jj) = visc_tra * (jj - (ilcj+1) ) * z1spongearea
+            ENDDO
+            spe1ur(1:jpim1,ilcj+1:nlcj-1) = 0.5 * ( zlocalviscsponge(1:jpim1,ilcj+1:nlcj-1) + zlocalviscsponge(2:jpi,ilcj+1:nlcj-1) ) &
+               &                                * e2u(1:jpim1,ilcj+1:nlcj-1) / e1u(1:jpim1,ilcj+1:nlcj-1)
+            spe2vr(:      ,ilcj+1:nlcj-2) = 0.5 * ( zlocalviscsponge(:,ilcj+1:nlcj-2      ) + zlocalviscsponge(:,ilcj+2:nlcj-1)     ) &
+               &                                * e1v(:,ilcj+1:nlcj-2) / e2v(:,ilcj+1:nlcj-2)
+         ENDIF
+         spongedoneT = .TRUE.
+      ENDIF
+
+      ! Dynamics
+      IF( .NOT. spongedoneU ) THEN
+         zlocalviscsponge(:,:) = 0.
+         spe1ur2(:,:) = 0.
+         spe2vr2(:,:) = 0.
+
+         IF( (nbondi == -1) .OR. (nbondi == 2) ) THEN
+            DO ji = 2, ispongearea
+               zlocalviscsponge(ji,:) = visc_dyn * ( ispongearea-ji ) * z1spongearea
+            ENDDO
+            spe1ur2(2:ispongearea-1,:      ) = 0.5 * ( zlocalviscsponge(2:ispongearea-1,:      ) + zlocalviscsponge(3:ispongearea,:    ) )
+            spe2vr2(2:ispongearea  ,1:jpjm1) = 0.5 * ( zlocalviscsponge(2:ispongearea  ,1:jpjm1) + zlocalviscsponge(2:ispongearea,2:jpj) ) 
+         ENDIF
+
+         IF( (nbondi == 1) .OR. (nbondi == 2) ) THEN
+            DO ji = ilci+1,nlci-1
+               zlocalviscsponge(ji,:) = visc_dyn * (ji - (ilci+1) ) * z1spongearea
+            ENDDO
+            spe1ur2(ilci+1:nlci-2,:      ) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-2,:) + zlocalviscsponge(ilci+2:nlci-1,:) )  
+            spe2vr2(ilci+1:nlci-1,1:jpjm1) = 0.5 * (  zlocalviscsponge(ilci+1:nlci-1,1:jpjm1) + zlocalviscsponge(ilci+1:nlci-1,2:jpj  )  ) 
+         ENDIF
+
+         IF( (nbondj == -1) .OR. (nbondj == 2) ) THEN
+            DO jj = 2, ispongearea
+               zlocalviscsponge(:,jj) = visc_dyn * ( ispongearea-jj ) * z1spongearea
+            ENDDO
+            spe1ur2(1:jpim1,2:ispongearea  ) = 0.5 * ( zlocalviscsponge(1:jpim1,2:ispongearea) + zlocalviscsponge(2:jpi,2:ispongearea) ) 
+            spe2vr2(:      ,2:ispongearea-1) = 0.5 * ( zlocalviscsponge(:,2:ispongearea-1)     + zlocalviscsponge(:,3:ispongearea)     )
+         ENDIF
+
+         IF( (nbondj == 1) .OR. (nbondj == 2) ) THEN
+            DO jj = ilcj+1,nlcj-1
+               zlocalviscsponge(:,jj) = visc_dyn * (jj - (ilcj+1) ) * z1spongearea
+            ENDDO
+            spe1ur2(1:jpim1,ilcj+1:nlcj-1) = 0.5 * ( zlocalviscsponge(1:jpim1,ilcj+1:nlcj-1) + zlocalviscsponge(2:jpi,ilcj+1:nlcj-1) ) 
+            spe2vr2(:      ,ilcj+1:nlcj-2) = 0.5 * ( zlocalviscsponge(:,ilcj+1:nlcj-2      ) + zlocalviscsponge(:,ilcj+2:nlcj-1)     )
+         ENDIF
+         spongedoneU = .TRUE.
+         spbtr3(:,:) = 1. / ( e1f(:,:) * e2f(:,:) )
+      ENDIF
+      !
+      CALL wrk_dealloc( jpi, jpj, zlocalviscsponge )
+      !
+#endif
+
+   END SUBROUTINE Agrif_Sponge
+
    SUBROUTINE interptsn(tabres,i1,i2,j1,j2,k1,k2,n1,n2)
       !!---------------------------------------------
       !!   *** ROUTINE interptsn ***
       !!---------------------------------------------
-#  include "domzgr_substitute.h90"       
-      
       INTEGER, INTENT(in) :: i1,i2,j1,j2,k1,k2,n1,n2
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2,n1:n2), INTENT(inout) :: tabres
@@ -341,6 +311,4 @@
       !!   *** ROUTINE interpun ***
       !!---------------------------------------------
-#  include "domzgr_substitute.h90"       
-      
       INTEGER, INTENT(in) :: i1,i2,j1,j2,k1,k2
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2), INTENT(inout) :: tabres
@@ -354,6 +322,4 @@
       !!   *** ROUTINE interpvn ***
       !!---------------------------------------------
-#  include "domzgr_substitute.h90"       
-      
       INTEGER, INTENT(in) :: i1,i2,j1,j2,k1,k2
       REAL(wp), DIMENSION(i1:i2,j1:j2,k1:k2), INTENT(inout) :: tabres
